package cn.com.infosec.asn1.cms;

import cn.com.infosec.asn1.ASN1Encodable;
import cn.com.infosec.asn1.ASN1OctetString;
import cn.com.infosec.asn1.ASN1TaggedObject;
import cn.com.infosec.asn1.DEREncodable;
import cn.com.infosec.asn1.DERObject;
import cn.com.infosec.asn1.DERTaggedObject;

public class RecipientIdentifier extends ASN1Encodable {
   private DEREncodable id;

   public RecipientIdentifier(IssuerAndSerialNumber id) {
      this.id = id;
   }

   public RecipientIdentifier(ASN1OctetString id) {
      RecipientIdentifier var10000 = this;
      super();
      DERTaggedObject var2;
      var2 = new DERTaggedObject.<init>(false, 0, id);
      var10000.id = var2;
   }

   public RecipientIdentifier(DERObject id) {
      this.id = id;
   }

   public static RecipientIdentifier getInstance(Object o) {
      if (o != null && !(o instanceof RecipientIdentifier)) {
         if (o instanceof IssuerAndSerialNumber) {
            return new RecipientIdentifier((IssuerAndSerialNumber)o);
         } else if (o instanceof ASN1OctetString) {
            return new RecipientIdentifier((ASN1OctetString)o);
         } else if (o instanceof DERObject) {
            return new RecipientIdentifier((DERObject)o);
         } else {
            throw new IllegalArgumentException("Illegal object in RecipientIdentifier: " + o.getClass().getName());
         }
      } else {
         return (RecipientIdentifier)o;
      }
   }

   public boolean isTagged() {
      return this.id instanceof ASN1TaggedObject;
   }

   public DEREncodable getId() {
      DEREncodable var1;
      return (DEREncodable)((var1 = this.id) instanceof ASN1TaggedObject ? ASN1OctetString.getInstance((ASN1TaggedObject)var1, false) : IssuerAndSerialNumber.getInstance(var1));
   }

   public DERObject toASN1Object() {
      return this.id.getDERObject();
   }
}
